<?
/*
 * ####################################################################
 * --------------------------------------------------------------------
 *                            XML Phorum 0.1
 *                    (Forum de discussion PHP en XML)
 *                       copyleft tobozo et leonard
 *         - tobozo@madchat.org
 *         - leonard@madchat.org
 *         - http://madchat.org/phorum/
 * --------------------------------------------------------------------
 *  Ce forum (le nom de votre forum) a t ralis sur la base du code
 *       de fouletexte 1.5 copyright (c) 2000 Thierry Arsicaud
 *             (http://www.echodelta.net/scriptsphp/).
 * --------------------------------------------------------------------
 * ####################################################################
 */


/* returns x whitespaces (or other caracter) into a string */
function whitespaces($x, $space=" ") {
  if($x==0) return false;
  elseif($x==1) return $space;
  elseif($x>0) {
    $i=0;
    while($i++<$x) {
      $whitespace.=$space;
      }
    return $whitespace;
    }
  else { // x not valid or negative
    return false;
    }
  }



  // ***************************************************************
  // Nettoyage des variables $nom,$adel,$sujet et $texte, par
  // limination des caractres /, | et #
  // ***************************************************************
  // -------------------------------------------------------------------
  // dfinition de la fonction stripSpeCar, destine  liminer
  // les caractres | et # susceptibles d'tre posts par l'utilisateur
  // -------------------------------------------------------------------

  function stripSpeCar($chaine) {
    //$chaine=str_replace("#","DIESECHAR",$chaine);
    //$chaine=str_replace("|","PIPECHAR",$chaine);
    $chaine=str_replace("madchat","mAdchAt",$chaine);
    $chaine=str_replace(" lol "," mdr ",$chaine);
    return($chaine);
    }



  // *********************************************************************
  // Dtermination du rang et du niveau du nouveau message
  // en fonction de la valeur "$refer".
  // *********************************************************************
  // Cette opration s'effectue par l'intermdiaire de la fonction
  // determin($valeur) qui accepte en entre la valeur $refer.
  // La fonction analyse le fichier index.dat, dtermine le rang et
  // le niveau du message prcdent ($rangMP,$niveauMP) et en dduit
  // les rangs et valeurs du nouveau message ($rangNM,$niveauNM).
  // Ces valeurs sont retournes sous la forme d'un tableau.
  // =====================================================================

  // ============================================
  // Dfinition de la fonction determin($valeur)
  // ============================================

  function determin($valeur) {

    global $index;
    $nombremsgs=count($index);
    if(!$valeur || $valeur=="0") {
      //die("Determin :: valeur is not valid\n<br>");
      $ary[1]=$nombremsgs;
      $ary[2]=1;
      return $ary;
      }
    if(!is_array($index)) die("Determin :: index $index is not an array\n<br>");
    if($nombremsgs<=1)  die("Determin :: nombremsgs $nombremsgs is not an array\n<br>");

    // ========== cas de figure o $valeur a t dfini ==========
    // recherche du rang et de du niveau du message prcdent
    $compt=1;
    while($index[$compt][1]!=$valeur) {
      $compt++;
      }

    // le rang et le niveau du message prcdent
    // sont stocks dans les valeurs $rangMP et $niveauMP
    $rangMP=$compt;
    $niveauMP=$index[$compt][2];

    // Dtermination du rang du nouveau message
    $compt=$compt+1;
    while(@ $index[$compt][2]>$niveauMP) {
      $compt++;
      }

    // le rang et le niveau du nouveau message
    // sont stocks dans les valeurs $rangNM et $niveauMP
    $ary[1]=$compt-1;
    $ary[2]=$niveauMP+1;
    // === La fonction retourne un tableau  deux lments (det[1] et det[2]), ===
    // ===      contenant respectivement les valeurs $rangNM et $niveauNM      ===
    return($ary);
    }


function do_header() {
  global $tpl;
  if(!$tpl) {
    $tpl = new template($tpl_dir);
    $tpl->debug = 0;
    $tpl->set_file(array(
     "header"     => "header.tpl"
     ));
    }
  $header .= $tpl->parse(OUT,"header");
  return $header;
  }


function do_footer() {
  global $tpl;
  if(!$tpl) {
    $tpl = new template($tpl_dir);
    $tpl->debug = 0;
    $tpl->set_file(array(
     "footer"     => "footer.tpl"
     ));
    }
  $footer .= $tpl->parse(OUT,"footer");
  return $footer;
  }


function do_threadlist_footer() {
  global $tpl;
  if(!$tpl) {
    $tpl = new template($tpl_dir);
    $tpl->debug = 0;
    }
  $tpl->set_file(array(
   "threadfooter"     => "footerThreadList.tpl"
   ));
  $footer .= $tpl->parse(OUT,"threadfooter");
  return $footer;
  }




function get_pass_from($file) {
   if(!file_exists($file)) return false;
   $ary = recuperer_message($file);
   return $ary[0];
   }




function elementDebut($parser, $name, $attrs) {
   global $thread, $iter, $ary;
   if($name=="ID")             $iter=0;
   elseif($name=="DATEHEURE")  $iter=1;
   elseif($name=="NOM")        $iter=2;
   elseif($name=="EMAIL")      $iter=3;
   elseif($name=="TITRE")      $iter=4;
   elseif($name=="MESSAGE")    $iter=5;
   else                   $iter=-1;
   //echo "&lt;$name&gt;";
   }

function elementFin($parser, $name) {
  return;
  //echo "&lt;/$name&gt;";
  }

function characterData($parser, $data) {
  global $thread, $iter,$ary;;
  $ary[$iter] .= $data;
  }

function recuperer_message($file) {
  if(!file_exists($file)) return false;
  global $ary;
  $ary = array();

  $xml_parser = xml_parser_create();
  // use case-folding so we are sure to find the tag in $map_array
  xml_parser_set_option($xml_parser, XML_OPTION_CASE_FOLDING, true);
  xml_set_element_handler($xml_parser, "elementDebut", "elementFin");
  xml_set_character_data_handler($xml_parser, "characterData");

  if (!($fp = fopen($file, "r"))) {
    die("could not open XML input");
    }
  while ($data = fread($fp, 4096)) {
    if (!xml_parse($xml_parser, $data, feof($fp))) {
        die(sprintf("erreur XML: %s  la ligne %d",
                    xml_error_string(xml_get_error_code($xml_parser)),
                    xml_get_current_line_number($xml_parser)));
        }
      }
  xml_parser_free($xml_parser);
  return $ary;
  }


function indexStart($parser, $name, $attrs) {
   global $thread, $iter, $ary;
   if($name=="ID")        $iter=1;
   elseif($name=="FROM")  $iter=2;
   elseif($name=="DATE")  $iter=3;
   elseif($name=="NOM")   $iter=4;
   elseif($name=="TITRE") $iter=5;
   else                   $iter=-1;
   //echo "&lt;$name&gt;";
   }

function indexEnd($parser, $name) {
  global $thread, $iter, $ary;
  if($name == "MESSAGE") {
    $thread++;
    return;
    }
  //echo "&lt;/$name&gt;";
  }

function charDt($parser, $data) {
  global $thread, $iter,$ary;;
  //print $data;
  if(!is_array($data) && (ltrim(chop($data))!="") && ($iter>-1)) {
    $ary[$thread+1][$iter] .= $data;
    //echo ($thread+1)." $iter $data \n";
    }
  }

function recuperer_index($file) {
  if(!file_exists($file)) return false;

  global $ary, $iter, $thread;

  $ary    = array();
  $iter   = -1;
  $thread = 0;

  $xml_parser = xml_parser_create();
  // use case-folding so we are sure to find the tag in $map_array
  xml_parser_set_option($xml_parser, XML_OPTION_CASE_FOLDING, true);
  xml_set_element_handler($xml_parser, "indexStart", "indexEnd");
  xml_set_character_data_handler($xml_parser, "charDt");

  if (!($fp = fopen($file, "r"))) {
    die("could not open XML input");
    }

  while ($data = fread($fp, 4096)) {
    if (!xml_parse($xml_parser, $data, feof($fp))) {
        die(sprintf("erreur XML: %s  la ligne %d",
                    xml_error_string(xml_get_error_code($xml_parser)),
                    xml_get_current_line_number($xml_parser)));
        }
      }
  xml_parser_free($xml_parser);
  fclose($fp);
  return $ary;
  }



function insert_data($ary, $pointer=0) {
  if(!is_array($ary)) die("Ary is not an array, failed updating index, exiting \n<br>");
  global $inc_dir, $tpl_dir, $msg_dir, $tpl, $index;
  if(!is_array($index)) die("Index file not loaded as an array, aborting \b<br>");

  $nombremsgs=count($index);
  $tpl->set_block("index", "loop_index", "indextpl");

  for($compt=1;$compt<=$pointer;$compt++) {
    $tpl->set_var(array(
       ID     =>$index[$compt][1], // identifiant du message
       FROM   =>$index[$compt][2], // niveau du message
       DATE   =>$index[$compt][3], // date
       NOM    =>$index[$compt][4], // nom de l'auteur
       TITRE  =>$index[$compt][5]  // sujet
       ));
    $tpl->parse("indextpl", "loop_index", true);
    }

  $tpl->set_var(array(
     ID     =>$ary[1], // identifiant du message
     FROM   =>$ary[2], // niveau du message
     DATE   =>$ary[3], // date
     NOM    =>$ary[4], // nom de l'auteur
     TITRE  =>$ary[5]  // sujet
     ));
  $tpl->parse("indextpl", "loop_index", true);
//  }

  for($compt=$pointer+1;$compt<=$nombremsgs;$compt++) {
    $tpl->set_var(array(
       ID     =>$index[$compt][1], // identifiant du message
       FROM   =>$index[$compt][2], // niveau du message
       DATE   =>$index[$compt][3], // date
       NOM    =>$index[$compt][4], // nom de l'auteur
       TITRE  =>$index[$compt][5]  // sujet
       ));
    $tpl->parse("indextpl", "loop_index", true);
    }

  $liste = fopen("index.xml", "w");
  fputs($liste, $tpl->parse(OUT,"index"));
  fclose($liste);
  return true;
  }


function tagster_format($str, $target="_self", $css_class="") {
    global $allow_html;
    $str = str_replace("<", "&lt;", $str);
    $str = str_replace(">", "&gt;", $str);
    $str = tagster_url($str, $target, $css_class);
    $str = tagster_email($str, $css_class);
    $str = tagster_fix_endchar($str);
    if($allow_html==1) $str = str_replace(array("  ", "\t", "\r", "\n"), array("&nbsp; ", "&nbsp;&nbsp;&nbsp; ", "", "<br />"), $str);
    return $str;
    }


function tagster_url($str, $target, $css_class) {
  $ins_str = "";
  if ($css_class) $ins_str .= " class=\"".$css_class."\"";
  if ($target) $ins_str .= " target=\"".$target."\"";
  $str = tagster_expand($str);
  /* OLD ONE
  $str=ereg_replace("((http|ftp)://([[:alnum:]]|[[:punct:]])+)", "<a href=\"\\1\"> \\1 </a>", $str);
  $str=ereg_replace(" (www\.([[:alnum:]]|[[:punct:]])+)", "<a href=\"http://\\1\"> \\0 </a>", $str);
  */
  $str = preg_replace ("/(ftp|http|https|telnet|news|nntp|file|irc):\/\/([a-z0-9~#%@&:;=!',_\(\)\?\/\.\-\+\[\]\|\*\$\^]+)/i", "<a href=\"\\1://\\2\"".$ins_str.">\\1://\\2</a>", $str);
  $str = preg_replace ("/([\s|\(\[\:])(www.)([a-z0-9~#%@&:;=!',_\(\)\?\/\.\-\+\[\]\|\*\$\^]+)/i", "\\1<a href=\"http://\\2\\3\"".$ins_str.">\\2\\3</a>", $str);
  $str = preg_replace ("/([\s|\(\[\:])(ftp.)([a-z0-9~#%@&:;=!',_\(\)\?\/\.\-\+\[\]\|\*\$\^]+)/i", "\\1<a href=\"ftp://\\2\\3\"".$ins_str.">\\2\\3</a>", $str);
  return tagster_reduce($str);
  }


function tagster_email($str, $css_class="") {
  $ins_class = "";
  if ($css_class) $ins_class = " class=\"".$css_class."\"";
  $str = tagster_expand($str);
  /* OLD ONE
  $str=ereg_replace("(([[:alnum:]]|[[:punct:]])+@([[:alnum:]]|[[:punct:]])+)", "<a href=\"mailto:\\1\"> \\0 </a>", $str);
  */
  $str = preg_replace ("/([\s|\"])([\w|\.|\-|_]+)@([\w||\-|_]+)\.([\w|\.|\-|_]+)/i", "\\1<a href=\"mailto:\\2@\\3.\\4\"".$ins_class.">\\2@\\3.\\4</a>", $str);
  return tagster_reduce($str);
  }


function tagster_fix_endchar($str) {
  $str = preg_replace ("/([\'|\)|\]|\.|\,|\?]){1}\">/i", "\">", $str);
  $str = preg_replace ("/([\'|\)|\]\.|\,|\?]){1}\" target=\"([a-z0-9~#%@&=!',_\-]+)\">/i", "\" target=\"\\1\">", $str);
  $str = preg_replace ("/([\'|\)|\]\.|\,|\?]){1}<\/a>/i", "</a>\\1", $str);
  return $str;
  }


function tagster_expand($str) {
  return " ".$str." ";
  }


function tagster_reduce($str) {
  return substr($str, 1, -1);
  }

?>